<?php

return array
(
	#　项目部署的相对路径（部署在服务器的根目录，如果不定义DEVER_PROJECT_NAME，则本项必须启用并有效）
	'path' => DIRECTORY_SEPARATOR . 'collect' . DIRECTORY_SEPARATOR,
	//'path' => DIRECTORY_SEPARATOR,
	
	# 名称
	'name' => '采集系统',
	# 基本描述
	'desc' => '专注编程与开发的架构',
	# copyright
	'copyright' => '© 2015-2020 dever.cc,Inc. Licensed under MIT license.',
	# github
	'github' => 'https://github.com/dever-main',
	# web
	'web' => 'http://www.dever.cc/',
	
	
	# 语言包设置
	'lang' => 'zh-cn',
	# api是否开启，默认关闭，如果开启，则所有数据接口必须接入api
	'api' => false,
	# 版本配置
	'version' => '1.0.0 Beta',
	
	# 模板（assets）的所在目录,默认为html
	'html' => 'html',
	
	# 使用的模板 注意：定义这个之后，将会强制将本项目模板变成这个 定义成数组的话则为pc和手机版
	//'template' => array('pc', 'm'),
	
	# 定义这个之后，将强制将template的目录改为这个，不定义或不填写，则强制使用为template定义
	//'service' => 'pc',
	
	# 访问assets的物理路径 这个是使用公共的路径
	//'assets'=> DEVER_PATH . '../assets/',
	
	# 访问assets目录的物理路径
	'assets' => DEVER_APP_PATH . 'assets' . DIRECTORY_SEPARATOR,

	# 访问data目录的物理路径
	'data' 	=> DEVER_PATH . 'web' . DIRECTORY_SEPARATOR . 'data' . DIRECTORY_SEPARATOR,

	# 访问当前项目目录的物理路径，如果项目和dever类库在一个目录中，则为DEVER_PATH，如果不在，则为DEVER_APP_PATH，当然也可随意更改，这里目前只影响合并操作
	'workspace' 	=> DEVER_PATH,

	# 替换设置 一般用于替换资源，将模板中的（html中的）js等相对url换成绝对url，如果不定义，则默认为../js这样的
	'replace' => array
	(
		'css' => '../css/',
		'js' => '../js/',
		'img' => '../images/',
		'core' => '../../lib/',
	),

	# 是否启用静态资源域名动态化，启用之后，静态资源的域名将动态加载，适合使用多个域名或publish启用
	'assets_domain' => true,
	
	# 定义api的token明文，如果和其他业务有合作，建议使用系统自带的接口api，自带加密解密程序。
	'token' => 'dever_api_2016',
	
	# 是否启用nocache，如果是互动类的项目且主域增加了cdn，建议开启
	'header-cache' => false,

	# 关闭自助建表，生产环境建议开启，开启之后无法对数据表进行更新操作
	//'create' => true,
	
	# 是否开启强制刷新页面缓存,值为$_GET的key值
	'template-cache' => 'dever_template_cache',
	
	# 是否开启手动更改模板，允许通过$_GET的方式来更改当前模板，值为$_GET的key值，默认关闭
	//'template' => 'dever_template',
	
	# 开启用户触发cron，主要用于无法加到系统计划任务的虚拟主机，必须安装manage组件，谨慎开启，会稍微影响程序执行效率
	//'cron' => true,
	
	# 是否开启mysql自助优化功能，开启后，会记录所有where条件和order的字段，可以方便的在后台进行分析、增加索引，必须安装manage组件
	'opt' => true,
	
	# 是否开启sql自动优化，将sql中的select * 转换为 select a,b形式，将sql中的where条件按照索引从左到右自动排序，必须打开上述的opt选项，数据量大时建议打开。
	//'sql' => true,

	# publish 是否发布，此项开启后，系统不会检测service（意味着不用将service打包上线），适合生产环境，并能对代码起到一定的加密保护。
	//'publish' => true,

	# url默认参数，所有Maze::url生成的链接都会加上这个参数
	//'url' => 'loading=content',
	//
	# 是否启用layout 如启用，填写要替换的class或者id即可，具体效果可参考youtube，只加载部分内容，前端请加载pjax.js
	//'layout' => '.content',
	
	# 是否启用自动过滤功能，必须加载manage包，目前可选的值为：manage（自带的过滤功能，非常简单，小型站点可以开启），bao10jie（必须申请账号）
	//'filter' => array('manage' => 1,'bao10jie' => '账号'),
	'filter' => array('manage' => 1),
);

