<?php

# 定义几个常用的选项
$option = array
(
	1 => '显示',
	2 => '不显示',
);

$cate = function()
{
	$array = array(-1 => array('name' => '父级分类'));
	$cate = Dever::load('collect/cate-main');
	if($cate)
	{
		$array += $cate;
	}
	return $array;
};

$time = time();

return array
(
	# 表名
	'name' => 'cate',
	# 显示给用户看的名称
	'lang' => '分类管理',
	# 后台菜单排序
	'order' => 10,
	# 数据结构
	'struct' => array
	(
		'id' 		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '分类ID',
			'default' 	=> '',
			'desc' 		=> '',
			'match' 	=> 'is_numeric',
			'search'	=> 'order',
			'list'		=> true,
		),
		
		'name'		=> array
		(
			'type' 		=> 'varchar-32',
			'name' 		=> '分类名称',
			'default' 	=> '',
			'desc' 		=> '请输入分类名称',
			'match' 	=> 'is_string',
			'update'	=> 'text',
			'search'	=> 'order,fulltext',
			//'list'		=> '"<a href=\"".Dever::url("thead/list?id={id}", "main")."\" target=\"_blank\">{name}</a>"',
			'list' 		=> true,
		),

		'cate_id'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '上级分类',
			'default' 	=> Dever::input('option_cate_id', -1),
			'desc' 		=> '上级分类',
			'match' 	=> 'is_numeric',
			'update'	=> 'select',
			'search'	=> 'order,select',
			//'list'		=> '{cate_id} > 0 ? Dever::load("forum/cate-one#name", {cate_id}) : "父级栏目"',
			'option' 	=> $cate,
		),
		
		'reorder'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '排序(数值越大越靠前)',
			'default' 	=> '1',
			'desc' 		=> '请输入排序',
			'match' 	=> 'option',
			'update'	=> 'text',
			'search'	=> 'order',
			'list_name' => '排序',
			'list'		=> true,
			'order'		=> 'desc',
			'edit'		=> true,
		),

		'state'		=> array
		(
			'type' 		=> 'tinyint-1',
			'name' 		=> '状态',
			'default' 	=> '1',
			'desc' 		=> '请选择状态',
			'match' 	=> 'is_numeric',
			'option' 	=> $option,
			'update'	=> 'radio',
		),
		
		'cdate'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '录入时间',
			'match' 	=> array('is_numeric', time()),
			'desc' 		=> '',
			# 只有insert时才生效
			'insert'	=> true,
			'list'		=> 'date("Y-m-d H:i:s", {cdate})',
		),
	),

	'manage' => array
	(
		# 列表页的类型
		'list_type' => 'parent',

		'list_button' => array
		(
			21 => array('新增子分类', '"cate&option_cate_id={id}&oper_parent=cate"', '{cate_id}<=0'),
			//6 => '删除'
		),
	),
	
	# request 请求接口定义
	'request' => array
	(	
		# main 取所有主栏目
		'main' => array
		(
			'where' => array
			(
				'cate_id' => -1,
				'state' => 1,
			),
			'type' => 'all',
			'order' => array('reorder` desc,`id', 'desc'),
			'col' => '*|id',
		),
		
		# 取所有下级栏目
		'child' => array
		(
			'where' => array
			(
				'cate_id' => array('1', '>='),
				'state' => 1,
			),
			'type' => 'all',
			'order' => array('reorder` desc,`id', 'desc'),
			'col' => '*|cate_id|id|',
		),
	),
);
