<?php
/*
|--------------------------------------------------------------------------
| menu.php 后台管理 左侧菜单管理
|--------------------------------------------------------------------------
*/
namespace DeverApp\Manage;

use Dever;
use DeverApp\Manage\Lib\Input as Html;
use Dever\Security\Api as Base;

Dever::load('manage/auth.init');

class Api
{
	/**
     * fast
     *
     * @var array
     */
	private $fast = array();
	
	/**
     * data
     *
     * @var array
     */
	private $data = array();

	function curl_multi_request ($query_arr) {
    $ch = curl_multi_init();
    $count = count($query_arr);
    $ch_child = array();
    foreach($query_arr as $k => $v)
    {
    	$ch_child[$k] = curl_init();
    	curl_setopt($ch_child[$k], CURLOPT_URL, $v);
        curl_setopt($ch_child[$k], CURLOPT_RETURNTRANSFER, true);
        curl_multi_add_handle($ch, $ch_child[$k]);
    }

    $run = null;

    do
    {
        curl_multi_exec($ch, $run);
    }
    while($run > 0);

    foreach($query_arr as $k => $v)
    {
        $result[$k] = curl_multi_getcontent($ch_child[$k]);
        curl_multi_remove_handle($ch, $ch_child[$k]);
    }
    curl_multi_close($ch);

    return $result;
}

	/**
     * 测试传统模板引擎（类似smarty）
     * 
     * @return array
     */
	public function test_display()
	{
		$data['test'] = 1111111111111;
		$data['data'] = $this->test_foreach();

		for($i=0;$i<100;$i++)
		{
			$data = Dever::load('upload/data!', array('i' => $i));

			echo $data . '<br >';
		}

		return $data;
		return Dever::render('example/render', $data);
	}

	public function test_display_data()
	{
		return 12323234;
	}

	public function test_foreach()
	{
		$config = array
		(
			array
			(
				'id' => 1,
				'name' => '1111',
				'child' => array
				(
					array
					(
						'id' => 3,
						'name' => '3333',
						'child' => array
						(
							array
							(
								'id' => 9,
								'name' => '9999',
							),
							array
							(
								'id' => 10,
								'name' => '10101010',
							)
						),
					),
					array
					(
						'id' => 4,
						'name' => '4444',
					)
				),
			),
			array
			(
				'id' => 2,
				'name' => '2222',
				'child' => array
				(
					array
					(
						'id' => 5,
						'name' => '5555',
					),
					array
					(
						'id' => 6,
						'name' => '6666',
					)
				),
			)
		);

		return $config;
	}

	/**
     * 测试接口定义
     * 
     * @return array
     */
	public function test_api()
	{
		$data = Dever::load('module/data.test');

		print_r($data);die;
	}

	/**
     * 测试逻辑验证步骤，必须包含step
     * 
     * @return array
     */
	public function test_step_1()
	{
		print_r(Dever::input('type'));
		# 传给下一步的数据
		Dever::setStep('test');

		$url = Dever::url('api.test_step_2?' . http_build_query(Dever::$global['step'][1]));

		print_r($url);die;

		#ok

		echo 11;die;
	}

	/**
     * 测试逻辑验证步骤，必须包含step
     * 
     * @return array
     */
	public function test_step_2()
	{
		$data = Dever::getStep();
		print_r($data);die;
		echo 22;die;
	}

	/**
     * 从数据库中得到所有接口，如果为空，则从项目中读取一次
     * 
     * @return array
     */
	private function get($auth = '')
	{
		$data = Dever::load('manage/api-all');
		
		if($data)
		{
			foreach($data as $k => $v)
			{
				
			}
		}
		else
		{
			# 数据为空，读取一次，后续就得手动读取了
			$this->load();
			
			$data = $this->get();
		}

		return $data;
	}
	
	/**
     * 更新接口
     * 
     * @return array
     */
	public function update()
	{
		$this->load();
		
		Dever::out('yes');
	}
	
	/**
     * 载入从项目中定义好的接口
     * 
     * @return array
     */
	public function load()
	{
		$project = Dever::load('manage/project.get');
		
		foreach($project as $k => $v)
		{
			$data = Base::init($v['path']);

			if($data)
			{
				foreach($data as $i => $j)
				{
					$j['order'] = isset($j['order']) ? $j['order'] : 1;

					$this->updateApi(Dever::url($i, $k), $j['name'], $j['type'], $k, $j['request'], $j['response'], $j['order']);
				}
			}
		}
	}
	
	private function updateApi($site, $name, $type, $project, $request, $response, $reorder)
	{
		$response_table = $request_table = '<table border=1 width=100% height=100%>';

		$response_table .= $response ? Dever::tbody(array('字段', '类型', '描述')) : '空';

		$request_table .= $request ? Dever::tbody(array('字段', '类型', '描述')) : '空';

		if($response)
		{
			$num = count($response);
			$table = array();
			foreach($response as $k => $v)
			{
				if(isset($v[0]) && $v[0] == '{struct}')
				{
					$table[$k] = '';
					unset($response[$k]);
					$struct = Dever::load($k . '--struct');
					if(isset($v[1]))
					{
						$data = $v[1];
					}
					else
					{
						$data = $struct;
					}

					if($data)
					{
						foreach($data as $i)
						{
							if(isset($struct[$i]) && isset($struct[$i]['type']))
							{
								$type = explode('-', $struct[$i]['type']);
								$table[$k] .= Dever::tbody(array($i, $type[0], $struct[$i]['name']));
							}
						}

						if(isset($v[2]))
						{
							$response[$v[2]] = array('array/json', $response_table . $table[$k] . '</table>');
						}
						else
						{
							$response_table .= $table[$k];
						}
					}
				}
			}
		}

		$this->table($response, $response_table);
		$this->table($request, $request_table);

		$info = Dever::load('manage/api-site', array('where_site' => $site));
		if(!$info)
		{
			$update['add_site'] = $site;
			$update['add_name'] = $name;
			$update['add_type'] = $type;
			$update['add_project'] = $project;
			$update['add_reorder'] = $reorder;
			$update['add_request'] = $request_table;
			$update['add_response'] = $response_table;
			$info['id'] = Dever::load('manage/api-insert', $update);
		}
		else
		{
			$update['set_site'] = $site;
			$update['set_name'] = $name;
			$update['set_type'] = $type;
			$update['set_project'] = $project;
			$update['set_reorder'] = $reorder;
			$update['set_request'] = $request_table;
			$update['set_response'] = $response_table;
			$update['where_id'] = $info['id'];

			Dever::load('manage/api-update', $update);
		}
		
		return $info['id'];
	}

	private function table($array, &$table)
	{
		if($array && is_array($array))
		{
			foreach($array as $k => $v)
			{
				if(is_array($v))
				{
					if(is_array($v[1]))
					{
						$tbody = '<table border=1 width=100% height=100%>';
						$this->table($v[1], $tbody) . '</table>';
						$v[1] = $tbody;
					}
					$table .= Dever::tbody(array($k, $v[0], $v[1]));
				}
				else
				{
					$string = 'string';
					if(strpos($v, 'id') !== false)
					{
						$string = 'int';
					}

					if(is_array($v))
					{
						$tbody = '<table border=1 width=100% height=100%>';
						$this->table($v, $tbody) . '</table>';
						$v = $tbody;
					}
					$table .= Dever::tbody(array($k, $string, $v));
				}
			}
		}

		$table .= '</table>';
	}
}
