<?php
/**
 * 上传表
 */
 
# 定义几个常用的选项
$option = array
(
	1 => '启用',
	2 => '关闭',
);

$water = array
(
	1 => '左上',
	2 => '左下',
	3 => '右上',
	4 => '右下',
	5 => '居中',
);

return array
(
	# 表名
	'name' => 'pic_water',
	# 显示给用户看的名称
	'lang' => '水印图配置',
	//'menu' => false,
	# 数据结构
	'struct' => array
	(
		'id' 		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '配置ID',
			'default' 	=> '',
			'desc' 		=> '',
			'match' 	=> 'is_numeric',
			'search'	=> 'order',
			'list'		=> true,
		),
		
		'name'		=> array
		(
			'type' 		=> 'varchar-24',
			'name' 		=> '配置名',
			'default' 	=> '',
			'desc' 		=> '请输入配置名',
			'match' 	=> 'is_string',
			'update'	=> 'text',
			'search'	=> 'fulltext',
			'list'		=> true,
		),
		
		'water'		=> array
		(
			'type' 		=> 'varchar-150',
			'name' 		=> '水印图',
			'default' 	=> '',
			'desc' 		=> '请选择水印图',
			'match' 	=> 'option',
			'update'	=> 'image',
			'key' 		=> '1',
			'place'		=> '150X150',
		),
		
		'water_position'		=> array
		(
			'type' 		=> 'int-1',
			'name' 		=> '水印图位置',
			'default' 	=> '1',
			'desc' 		=> '请选择水印图位置',
			'match' 	=> 'is_numeric',
			'option' 	=> $water,
			'update'	=> 'select',
			//'list'		=> true,
		),
		
		'state'		=> array
		(
			'type' 		=> 'tinyint-1',
			'name' 		=> '状态',
			'default' 	=> '1',
			'desc' 		=> '请选择状态',
			'match' 	=> 'is_numeric',
			'option' 	=> $option,
			'update'	=> 'radio',
			'list'		=> true,
		),
		
		'cdate'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '录入时间',
			'match' 	=> array('is_numeric', time()),
			'desc' 		=> '',
			# 只有insert时才生效
			'insert'	=> true,
			'list'		=> 'date("Y-m-d H:i:s", {cdate})',
		),
	),
	
	# request 请求接口定义
	'request' => array
	(
		# info 取一条正常的数据
		'info' => array
		(
			# 匹配的正则或函数 必填项
			'where' => array
			(
				'id' => 'is_numeric',
				'state' => 1,
			),
			'type' => 'one',
		),
	),
);
