<?php
/**
 * 上传表
 */
 
# 定义几个常用的选项
$option = array
(
	1 => '启用',
	2 => '关闭',
);

$cover = array
(
	1 => '覆盖原文件',
	2 => '不覆盖，提示错误',
	3 => '不覆盖，直接生成新文件',
);

return array
(
	# 表名
	'name' => 'upload',
	# 显示给用户看的名称
	'lang' => '上传基本配置',
	'order'	=> 10,
	# 数据结构
	'struct' => array
	(
		'id' 		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '配置ID',
			'default' 	=> '',
			'desc' 		=> '',
			'match' 	=> 'is_numeric',
			'search'	=> 'order',
			'list'		=> true,
		),
		
		'name'		=> array
		(
			'type' 		=> 'varchar-24',
			'name' 		=> '配置名',
			'default' 	=> '',
			'desc' 		=> '请输入配置名',
			'match' 	=> 'is_string',
			'update'	=> 'text',
			'search'	=> 'fulltext',
			'list'		=> true,
		),
		
		'width'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '限制宽度',
			'default' 	=> '0',
			'desc' 		=> '请输入宽度',
			'match' 	=> 'option',
			'update'	=> 'text',
			'list'		=> true,
		),
		
		'height'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '限制高度',
			'default' 	=> '0',
			'desc' 		=> '请输入高度',
			'match' 	=> 'option',
			'update'	=> 'text',
			'list'		=> true,
		),
		
		'size'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '限制大小（字节）',
			'default' 	=> '0',
			'desc' 		=> '请输入大小',
			'match' 	=> 'option',
			'update'	=> 'text',
			'list'		=> true,
		),
		
		'type'		=> array
		(
			'type' 		=> 'varchar-255',
			'name' 		=> '限制文件后缀类型-多个用逗号隔开',
			'default' 	=> '',
			'desc' 		=> '请输入限制文件类型',
			'match' 	=> 'option',
			'update'	=> 'text',
			'list'		=> true,
		),
		
		'cover'		=> array
		(
			'type' 		=> 'int-1',
			'name' 		=> '是否覆盖',
			'default' 	=> '1',
			'desc' 		=> '请选择是否覆盖',
			'match' 	=> 'is_numeric',
			'option' 	=> $cover,
			'update'	=> 'radio',
			'list'		=> true,
		),
		
		'state'		=> array
		(
			'type' 		=> 'tinyint-1',
			'name' 		=> '状态',
			'default' 	=> '1',
			'desc' 		=> '请选择状态',
			'match' 	=> 'is_numeric',
			'option' 	=> $option,
			'update'	=> 'radio',
			'list'		=> true,
		),
		
		'cdate'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '录入时间',
			'match' 	=> array('is_numeric', time()),
			'desc' 		=> '',
			# 只有insert时才生效
			'insert'	=> true,
			'list'		=> 'date("Y-m-d H:i:s", {cdate})',
		),
	),
	
	# 默认值
	'default' => array
	(
		'col' => 'name,cover,type,state,cdate',
		'value' => array
		(
			'"默认图片配置",1,"jpg,png,gif",1,' . time(),
			'"默认音频配置",1,"mp3",1,' . time(),
			'"默认视频配置",1,"mp4",1,' . time(),
			'"默认文件配置",1,"jpg,png,gif,doc,pdf,rar,zip,xls,xlsx,docx",1,' . time(),
		),
	),
	
	# request 请求接口定义
	'request' => array
	(
		# info 取一条正常的数据
		'info' => array
		(
			# 匹配的正则或函数 必填项
			'where' => array
			(
				'id' => 'is_numeric',
				'state' => 1,
			),
			'type' => 'one',
		),
	),
);
